//+------------------------------------------------------------------+
//|                                                 CurrentTrend.mq4 |
//|                                                        Scriptong |
//|                  http://forum.radioforex.ru/viewtopic.php?t=1286 |
//+------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "http://forum.radioforex.ru/viewtopic.php?t=1286"

#property indicator_chart_window
//---- input parameters
extern string    A1=",    ";
extern string    A2="H1 - 60, H4 - 240, D1 - 1440, W1 - 10080";
extern int       FractalTF=240;

double UpFractal1 = 0, UpFractal2 = 0;
double DownFractal1 = 0, DownFractal2 = 0;
datetime TU1=0, TU2=0, TD1=0, TD2=0;
datetime LastBarTime = 0;
bool Activate = False;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(CalcTF() == "")
     { 
      Comment("  !");
      return(0); 
      }

   if(!ObjectCreate("Channel", OBJ_CHANNEL, 0, 0, 0, 0, 0, 0, 0))
     return(0);
   if(!ObjectCreate("Fibo", OBJ_FIBO, 0, 0, 0, 0))
     return(0);
   ObjectSet("Fibo", OBJPROP_FIBOLEVELS, 10);
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL, 0.0);
   ObjectSetFiboDescription("Fibo", 0, "+0.0     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+1, 0.382);
   ObjectSetFiboDescription("Fibo", 1, "+38.2     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+2, 0.5);
   ObjectSetFiboDescription("Fibo", 2, "+50.0     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+3, 0.618);
   ObjectSetFiboDescription("Fibo", 3, "+61.8     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+4, 1.0);
   ObjectSetFiboDescription("Fibo", 4, "+100.0     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+5, 1.382);
   ObjectSetFiboDescription("Fibo", 5, "+138.2     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+6, 1.618);
   ObjectSetFiboDescription("Fibo", 6, "+161.8     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+7, 2.0);
   ObjectSetFiboDescription("Fibo", 7, "+200.0     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+8, 2.618);
   ObjectSetFiboDescription("Fibo", 8, "+261.8     ");
   ObjectSet("Fibo", OBJPROP_FIRSTLEVEL+9, 3.0);
   ObjectSetFiboDescription("Fibo", 9, "+300.0     ");
   Activate = True;
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    ObjectDelete("Channel");
    ObjectDelete("Fibo");
    Comment("");
//----
   return(0);
  }
 
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
int FindFractals()
{
   UpFractal1 = 0;
   UpFractal2 = 0;
   DownFractal1 = 0;
   DownFractal2 = 0;
   TU1 = 0; TU2 = 0;
   TD1 = 0; TD2 = 0;
   
   int i = 3;
   while((UpFractal1 == 0 || UpFractal2 == 0 || DownFractal1 == 0 || DownFractal2 == 0) && i < Bars)
     {
       double Up = iFractals(Symbol(), FractalTF, MODE_UPPER, i);
       double Dn = iFractals(Symbol(), FractalTF, MODE_LOWER, i);
       if(Up != 0)
         if(UpFractal1 == 0)
            {
              UpFractal1 = Up;
              TU1 = iTime(Symbol(), FractalTF, i);
             } 
           else
            if(UpFractal2 == 0)
              {
                UpFractal2 = Up; 
                TU2 = iTime(Symbol(), FractalTF, i);
               } 
       if(Dn != 0)
         if(DownFractal1 == 0)
           { 
             DownFractal1 = Dn;
             TD1 = iTime(Symbol(), FractalTF, i);
            } 
           else
             if(DownFractal2 == 0)
               {
                 DownFractal2 = Dn;       
                 TD2 = iTime(Symbol(), FractalTF, i);
                }
       i++;
      }
   //     

 return(i);
 }  
 
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
string CalcTF()
{
  string Res = "";
  if(FractalTF == 0)
    FractalTF = Period();
    
  switch(FractalTF)
    {
     case 1: Res = "M1"; break;
     case 5: Res = "M5"; break;
     case 15: Res = "M15"; break;
     case 30: Res = "M30"; break;
     case 60: Res = "H1"; break;
     case 240: Res = "H4"; break;
     case 1440: Res = "D1"; break;
     case 10080: Res = "W1"; break;
     case 43200: Res = "MN1"; break;
     }
  return(Res);   
 } 
 
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+ 
void MoveChannel(datetime X1, double Y1, datetime X2, double Y2, datetime X3, double Y3)
{
   ObjectMove("Channel", 0, X1, Y1);
   ObjectMove("Channel", 1, X2, Y2);
   ObjectMove("Channel", 2, X3, Y3);
   ObjectMove("Fibo", 1, X1, Y1);
   ObjectMove("Fibo", 0, X3, Y3);
   return;
 }
 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   //    ,    
   if(!Activate)
     return(0);

   //     ,     
   if(LastBarTime == iTime(Symbol(), FractalTF, 0))
     return(0);
    
   //      
   LastBarTime = iTime(Symbol(), FractalTF, 0);  
       
   //      ,  , . ., ,     4- 
   if(FindFractals() == Bars)
     return(0);   

   //   -  
   //   UpFractal1 ,  UpFractal2.        
   if(UpFractal1 > UpFractal2 && DownFractal1 > DownFractal2)
     {
       MoveChannel(TU1, UpFractal1, TU2, UpFractal2, TD1, DownFractal1);
       return(0);
      }   

   //   -  
   //   UpFractal1 ,  UpFractal2.        
   if(UpFractal1 < UpFractal2 && DownFractal1 < DownFractal2)
     {
       MoveChannel(TD1, DownFractal1, TD2, DownFractal2, TU1, UpFractal1);
       return(0);
      }   
 
   //         
   MoveChannel(0, 0, 0, 0, 0, 0);   
   Comment("     ", CalcTF());   

//----
   return(0);
  }
//+------------------------------------------------------------------+